// Generated by gtkmmproc -- DO NOT MODIFY!


#include <libgdamm/serveroperation.h>
#include <libgdamm/private/serveroperation_p.h>

/* $Id: serveroperation.ccg,v 1.1 2006/07/04 16:39:22 murrayc Exp $ */
// -*- C++ -*- // this is for the .ccg, I realize gensig puts one in

/* serveroperation.cc
 * 
 * Copyright 2006 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgda/gda-server-operation.h>
#include <libgda/gda-enum-types.h>
#include <libgda/gda-easy.h>
#include <libgdamm/connection.h>

namespace Gnome
{

namespace Gda
{

#ifdef GLIBMM_EXCEPTIONS_ENABLED
Glib::RefPtr<ServerOperation> ServerOperation::prepare_create_database(const Glib::ustring& provider,
                                                                       const Glib::ustring& db_name)
#else
Glib::RefPtr<ServerOperation> ServerOperation::prepare_create_database(const Glib::ustring& provider,
                                                                       const Glib::ustring& db_name,
                                                                       std::auto_ptr<Glib::Error>& error)
#endif
{
  GError* gerror = 0;
  Glib::RefPtr<ServerOperation> op = 
    Glib::wrap(gda_prepare_create_database(provider.c_str(), db_name.c_str(), &gerror));

#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror) ::Glib::Error::throw_exception(gerror);
#else
  if(gerror) error = ::Glib::Error::throw_exception(gerror);
#endif // GLIBMM_EXCEPTIONS_ENABLED
  
  return op;   
}

#ifdef GLIBMM_EXCEPTIONS_ENABLED
Glib::RefPtr<ServerOperation> ServerOperation::prepare_drop_database(const Glib::ustring& provider,
                                                                     const Glib::ustring& db_name)
#else
Glib::RefPtr<ServerOperation> ServerOperation::prepare_drop_database(const Glib::ustring& provider,
                                                                     const Glib::ustring& db_name,
                                                                     std::auto_ptr<Glib::Error>& error)
#endif
{
  GError* gerror = 0;
  Glib::RefPtr<ServerOperation> op = 
    Glib::wrap(gda_prepare_drop_database(provider.c_str(), db_name.c_str(), &gerror));

#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror) ::Glib::Error::throw_exception(gerror);
#else
  if(gerror) error = ::Glib::Error::throw_exception(gerror);
#endif // GLIBMM_EXCEPTIONS_ENABLED
  
  return op;   
}

#ifdef GLIBMM_EXCEPTIONS_ENABLED
bool ServerOperation::perform_drop_database(const Glib::ustring& provider)
#else
bool ServerOperation::perform_drop_database(const Glib::ustring& provider,
                                            std::auto_ptr<Glib::Error>& error)
#endif
{
  GError* gerror = 0;
  bool retval = 
    static_cast<bool>(gda_perform_drop_database(provider.c_str(), gobj(), &gerror));

#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror) ::Glib::Error::throw_exception(gerror);
#else
  if(gerror) error = ::Glib::Error::throw_exception(gerror);
#endif // GLIBMM_EXCEPTIONS_ENABLED
  
  return retval;
}

#ifdef GLIBMM_EXCEPTIONS_ENABLED
bool ServerOperation::perform_create_database(const Glib::ustring& provider)
#else
bool ServerOperation::perform_create_database(const Glib::ustring& provider,
                                              std::auto_ptr<Glib::Error>& error)
#endif
{
  GError* gerror = 0;
  bool retval = 
    static_cast<bool>(gda_perform_create_database(provider.c_str(), gobj(), &gerror));

#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror) ::Glib::Error::throw_exception(gerror);
#else
  if(gerror) error = ::Glib::Error::throw_exception(gerror);
#endif // GLIBMM_EXCEPTIONS_ENABLED
  
  return retval;
}

Value ServerOperation::get_value_at(const Glib::ustring& path) const
{
  Value retval;
  const GValue* value = gda_server_operation_get_value_at(const_cast<GdaServerOperation*>(gobj()), "%s", path.c_str());
  retval.init(value);
  return retval;
}  

#ifdef GLIBMM_EXCEPTIONS_ENABLED
void ServerOperation::set_value_at_as_value(const Glib::ustring& path, const Glib::ValueBase& value)
#else
void ServerOperation::set_value_at_as_value(const Glib::ustring& path, const Glib::ValueBase& value, std::auto_ptr<Glib::Error>& error)
#endif // GLIBMM_EXCEPTIONS_ENABLED
{
  gchar* strvalue = gda_value_stringify(value.gobj());
  GError* gerror = 0;
  gda_server_operation_set_value_at(gobj(), strvalue, &gerror, "%s", path.c_str());
  g_free(strvalue);

#ifdef GLIBMM_EXCEPTIONS_ENABLED
  if(gerror) ::Glib::Error::throw_exception(gerror);
#else
  if(gerror) error = ::Glib::Error::throw_exception(gerror);
#endif // GLIBMM_EXCEPTIONS_ENABLED
}

} /* namespace Gda */

} /* namespace Gnome */


namespace
{


static void ServerOperation_signal_signal_sequence_item_added_callback(GdaServerOperation* self, const gchar* p0,gint p1,void* data)
{
  using namespace Gnome::Gda;
  typedef sigc::slot< void,Glib::ustring,int > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(Glib::convert_const_gchar_ptr_to_ustring(p0)
, p1
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
}

static const Glib::SignalProxyInfo ServerOperation_signal_signal_sequence_item_added_info =
{
  "sequence-item-added",
  (GCallback) &ServerOperation_signal_signal_sequence_item_added_callback,
  (GCallback) &ServerOperation_signal_signal_sequence_item_added_callback
};


static void ServerOperation_signal_signal_sequence_item_remove_callback(GdaServerOperation* self, const gchar* p0,gint p1,void* data)
{
  using namespace Gnome::Gda;
  typedef sigc::slot< void,Glib::ustring,int > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(Glib::convert_const_gchar_ptr_to_ustring(p0)
, p1
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
}

static const Glib::SignalProxyInfo ServerOperation_signal_signal_sequence_item_remove_info =
{
  "sequence-item-remove",
  (GCallback) &ServerOperation_signal_signal_sequence_item_remove_callback,
  (GCallback) &ServerOperation_signal_signal_sequence_item_remove_callback
};


} // anonymous namespace

// static
GType Glib::Value<Gnome::Gda::ServerOperationNodeType>::value_type()
{
  return gda_server_operation_node_type_get_type();
}

// static
GType Glib::Value<Gnome::Gda::ServerOperationNodeStatus>::value_type()
{
  return gda_server_operation_node_status_get_type();
}

// static
GType Glib::Value<Gnome::Gda::ServerOperationType>::value_type()
{
  return gda_server_operation_type_get_type();
}


namespace Glib
{

Glib::RefPtr<Gnome::Gda::ServerOperation> wrap(GdaServerOperation* object, bool take_copy)
{
  return Glib::RefPtr<Gnome::Gda::ServerOperation>( dynamic_cast<Gnome::Gda::ServerOperation*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gnome
{

namespace Gda
{


/* The *_Class implementation: */

const Glib::Class& ServerOperation_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &ServerOperation_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gda_server_operation_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void ServerOperation_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* ServerOperation_Class::wrap_new(GObject* object)
{
  return new ServerOperation((GdaServerOperation*)object);
}


/* The implementation: */

GdaServerOperation* ServerOperation::gobj_copy()
{
  reference();
  return gobj();
}

ServerOperation::ServerOperation(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{

}

ServerOperation::ServerOperation(GdaServerOperation* castitem)
:
  Glib::Object((GObject*)(castitem))
{}


ServerOperation::~ServerOperation()
{}


ServerOperation::CppClassType ServerOperation::serveroperation_class_; // initialize static member

GType ServerOperation::get_type()
{
  return serveroperation_class_.init().get_type();
}


GType ServerOperation::get_base_type()
{
  return gda_server_operation_get_type();
}


ServerOperationNodeType ServerOperation::get_node_type(const Glib::ustring& path, ServerOperationNodeStatus& status) const
{
  return ((ServerOperationNodeType)(gda_server_operation_get_node_type(const_cast<GdaServerOperation*>(gobj()), path.c_str(), ((GdaServerOperationNodeStatus*) &(status)))));
}

guint ServerOperation::get_sequence_size(const Glib::ustring& path) const
{
  return gda_server_operation_get_sequence_size(const_cast<GdaServerOperation*>(gobj()), path.c_str());
}

guint ServerOperation::get_sequence_max_size(const Glib::ustring& path) const
{
  return gda_server_operation_get_sequence_max_size(const_cast<GdaServerOperation*>(gobj()), path.c_str());
}

guint ServerOperation::get_sequence_min_size(const Glib::ustring& path) const
{
  return gda_server_operation_get_sequence_min_size(const_cast<GdaServerOperation*>(gobj()), path.c_str());
}

std::vector<Glib::ustring> ServerOperation::get_sequence_item_names(const Glib::ustring& path) const
{
  return Glib::ArrayHandler<Glib::ustring>::array_to_vector(gda_server_operation_get_sequence_item_names(const_cast<GdaServerOperation*>(gobj()), path.c_str()), Glib::OWNERSHIP_SHALLOW);
}

Glib::ustring ServerOperation::get_sequence_name(const std::string& path) const
{
  return Glib::convert_const_gchar_ptr_to_ustring(gda_server_operation_get_sequence_name(const_cast<GdaServerOperation*>(gobj()), path.c_str()));
}

bool ServerOperation::is_valid(const std::string& xml_file) const
{
  GError* gerror = 0;
  bool retvalue = gda_server_operation_is_valid(const_cast<GdaServerOperation*>(gobj()), xml_file.c_str(), &(gerror));
  if(gerror)
    ::Glib::Error::throw_exception(gerror);

  return retvalue;

}

bool ServerOperation::load_data_from_xml(xmlNodePtr node)
{
  GError* gerror = 0;
  bool retvalue = gda_server_operation_load_data_from_xml(gobj(), node, &(gerror));
  if(gerror)
    ::Glib::Error::throw_exception(gerror);

  return retvalue;

}

xmlNodePtr ServerOperation::save_data_to_xml()
{
  GError* gerror = 0;
  xmlNodePtr retvalue = gda_server_operation_save_data_to_xml(gobj(), &(gerror));
  if(gerror)
    ::Glib::Error::throw_exception(gerror);

  return retvalue;

}

Glib::ustring ServerOperation::get_node_path_portion(const Glib::ustring& path) const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gda_server_operation_get_node_path_portion(const_cast<GdaServerOperation*>(gobj()), path.c_str()));
}

Glib::ustring ServerOperation::get_node_parent(const Glib::ustring& path) const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gda_server_operation_get_node_parent(const_cast<GdaServerOperation*>(gobj()), path.c_str()));
}

ServerOperationType ServerOperation::get_op_type() const
{
  return ((ServerOperationType)(gda_server_operation_get_op_type(const_cast<GdaServerOperation*>(gobj()))));
}

bool ServerOperation::del_item_from_sequence(const std::string& item_path)
{
  return gda_server_operation_del_item_from_sequence(gobj(), item_path.c_str());
}

guint ServerOperation::add_item_to_sequence(const std::string& item_path)
{
  return gda_server_operation_add_item_to_sequence(gobj(), item_path.c_str());
}

std::vector<Glib::ustring> ServerOperation::get_root_nodes() const
{
  return Glib::ArrayHandler<Glib::ustring>::array_to_vector(gda_server_operation_get_root_nodes(const_cast<GdaServerOperation*>(gobj())), Glib::OWNERSHIP_SHALLOW);
}


Glib::SignalProxy2< void,Glib::ustring,int > ServerOperation::signal_signal_sequence_item_added()
{
  return Glib::SignalProxy2< void,Glib::ustring,int >(this, &ServerOperation_signal_signal_sequence_item_added_info);
}


Glib::SignalProxy2< void,Glib::ustring,int > ServerOperation::signal_signal_sequence_item_remove()
{
  return Glib::SignalProxy2< void,Glib::ustring,int >(this, &ServerOperation_signal_signal_sequence_item_remove_info);
}


#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Connection> > ServerOperation::property_connection() const
{
  return Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Connection> >(this, "connection");
}
#endif //GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
Glib::PropertyProxy_ReadOnly<gint> ServerOperation::property_op_type() const
{
  return Glib::PropertyProxy_ReadOnly<gint>(this, "op-type");
}
#endif //GLIBMM_PROPERTIES_ENABLED


} // namespace Gda

} // namespace Gnome


